

#!/bin/sh

#
## Usage:
##    sgzip name
##
## Description:
##    sgzip reduces the size of the named file using
##    Semantic Redundancy Reduction (SRR).
##
 

INPUT=$1
BASE=`echo $INPUT | sed 's/^\(.*\)\.[^\.]*$/\1/'`
OUTPUT="${BASE}.sgz"


echo
echo "Semantic GZIP v0.1"
echo "German Version (c) iX 1998"
echo "by Stefan Mintert"
echo

if [ $# -eq 0 ]
then
  cat $0 | grep '^##' | sed 's/##//'
  exit
fi

if [ -f "$OUTPUT" ]
then
  mv -f $OUTPUT $OUTPUT-old
fi

echo "Reading $INPUT"

cat $INPUT  | while read ZEILE
do
  echo ".\c"
  echo $ZEILE | sed -n '/^.*'`echo "\0115\0141\0163\0163\c"`'.*$/ p' | sed 's/^.*\('`echo "\0115\0141\0163\0163\c"`'\).*$/'`echo
"\0101\0160\0162\0151\0154/\c"` >> $OUTPUT
done
echo
echo "Compression of $INPUT finished. Result was written to $OUTPUT"


VORHER=`wc -c $INPUT   | sed 's/[^0-9]*\([0-9]*\)[^0-9]*/\1/'`
NACHHER=`wc -c $OUTPUT | sed 's/[^0-9]*\([0-9]*\)[^0-9]*/\1/'`

echo 5 > tmp-$$-sgzip
echo k >> tmp-$$-sgzip
echo $NACHHER >> tmp-$$-sgzip
echo $VORHER >> tmp-$$-sgzip
echo "/" >> tmp-$$-sgzip
echo "p" >> tmp-$$-sgzip

ERGEBNIS=`dc < tmp-$$-sgzip`

echo --------------------------
echo "Compression rate: ${ERGEBNIS}%" 
echo --------------------------

rm tmp-$$-sgzip


exit

